/***********************************************************************/
/*                                                                     */
/*                            Pio (Fortran)                            */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2005-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Francois Clement <Francois.Clement@inria.fr>                       */
/*  Pierre Weis <Pierre.Weis@inria.fr>                                 */
/*  Hend Ben Ameur <hbenameur@yahoo.ca>                                */
/*                                                                     */
/***********************************************************************/

/* $Id: pio_configurable_constants.h,v 1.11 2014/03/07 19:21:42 fclement Exp $ */

/* Programmer's definable constants */

#ifndef _PIO_CONFIGURABLE_CONSTANTS_H_
#define _PIO_CONFIGURABLE_CONSTANTS_H_

/* Machine dependant constant sizes */
/* Natural size of an integer in characters (a word) */
#define INT_SIZE 4
/* Size of a floating point number in characters */
#define FLOAT_SIZE 8

/* Float formats */
#define FLOAT_FORMAT_DECIMALS 16
#define SCAN_FLOAT_FORMAT_LENGTH 24 /* = FLOAT_FORMAT_DECIMALS + 8 */
#define SCAN_FLOAT_FORMAT *
                    /* = 1peSCAN_FLOAT_FORMAT_LENGTH.FLOAT_FORMAT_DECIMALSe3 */
#define PRINT_FLOAT_FORMAT_LENGTH 24 /* = FLOAT_FORMAT_DECIMALS + 8 */
#define PRINT_FLOAT_FORMAT 1pe24.16e3
                   /* = 1pePRINT_FLOAT_FORMAT_LENGTH.FLOAT_FORMAT_DECIMALSe3 */

/* The allocated sizes of the scanning and printing buffers in characters. */
#define BUFFER_SIZE KIBI
#define PIO_MAX_IDENT_LENGTH 42
#define MAX_FLOAT_LENGTH 128
#define MAX_INT_LENGTH 32

/* The allocated size of the memory buffer used by the library in characters */
#define MEMORY_SIZE (128 * MEBI)

/* Maximal number of values read in a single communication. */
#define MAX_VALUE_NUMBER KIBI

/* Maximal size for vectors (for reporting only). */
#define MAX_VECTOR_SIZE KIBI

/* Maximal number of dimensions for multi-dimensional arrays. */
#define MAX_ARRAY_DIMENSION 8

/* Maximal number of items for compound string values. */
#define MAX_STRING_ITEMS KIBI

/* Maximal length for error messages. */
#define MAX_ERROR_MSG_LENGTH 80

#endif
