(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2013-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uvector_types.ml,v 1.9 2014-02-10 18:12:49 fclement Exp $ *)

let v_qual = Upervasives.qualify "Uvector";;

let v_failwith = Upervasives.failwith_qual v_qual;;

(* This functor must be defined before interface only module Vector_spec
 so that it can be used in it to define module type Vector_spec.MAKER.
 Hence, vector_types stuff cannot be incorporated into vector counterparts,
 i.e. Vector_types_spec into Vector_spec, and Vector_types into Vector. *)

module Make =
  functor (Dim : Uvector_types_spec.DIMENSION) ->
struct
  type 'a t = 'a array;;
  
  let to_vector a =
    if Uarray.length a <> Dim.get_dim () then
      v_failwith "of_array" "wrong length" else
    a
  ;;
  
  external of_vector : 'a t -> 'a array = "%identity";;
end
;;
